module StackQuSpec where

import qualified Queue as Q
import Queue(Qu)
import qualified Stack as S
import Stack(St)

-- Build and consume for Queues
buildQ :: [alpha]-> Qu alpha
buildQ xs = foldl (flip Q.enq) Q.empty xs

useQ :: Eq alpha=> Qu alpha-> [alpha]
useQ q | q == Q.empty = []
       | otherwise    = Q.first q : useQ (Q.deq q)

-- Build and consume for Lists
buildS :: [alpha]-> St alpha
buildS xs = foldl (flip S.push) S.empty xs

useS :: Eq alpha=> St alpha-> [alpha]
useS s | s == S.empty = []
       | otherwise    = S.top s : useS (S.pop s)
